CREATE TABLE collection (id integer NOT NULL PRIMARY KEY AUTOINCREMENT,title text NOT NULL UNIQUE COLLATE NOCASE,sort text COLLATE NOCASE,uid text,pictureID integer DEFAULT 0,locationID integer DEFAULT 0,rating float NOT NULL DEFAULT 0, accrualPolicy text, accrualPeriodicity text);
CREATE TABLE collection_annotations_link (id integer NOT NULL PRIMARY KEY AUTOINCREMENT UNIQUE,collectionID integer NOT NULL,annotationsID integer NOT NULL);
CREATE TABLE collection_reviews_link (id integer NOT NULL PRIMARY KEY AUTOINCREMENT UNIQUE,collectionID integer NOT NULL,reviewID integer NOT NULL);
CREATE TABLE contributor (id integer NOT NULL PRIMARY KEY AUTOINCREMENT UNIQUE,name text NOT NULL DEFAULT unknown COLLATE NOCASE,sort text COLLATE NOCASE,pictureID integer, descriptionID integer DEFAULT 0,locationID integer DEFAULT 0);
CREATE TABLE dbobject_history (id integer NOT NULL PRIMARY KEY AUTOINCREMENT UNIQUE,objID text UNIQUE,creationDate timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,modificationDate timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP);
CREATE TABLE annotations (id integer NOT NULL PRIMARY KEY AUTOINCREMENT UNIQUE,content text NOT NULL COLLATE NOCASE,role varchar NOT NULL DEFAULT descrpt COLLATE NOCASE);
CREATE TABLE location (id integer NOT NULL PRIMARY KEY AUTOINCREMENT UNIQUE,data blob NOT NULL,label text,type text NOT NULL DEFAULT url);
CREATE TABLE pictures (id integer NOT NULL PRIMARY KEY AUTOINCREMENT UNIQUE,picture blob NOT NULL,label text);
CREATE TABLE resource (id integer NOT NULL PRIMARY KEY AUTOINCREMENT,title text NOT NULL DEFAULT Untitled COLLATE NOCASE,pubblicationDate date,type text,genre text,uid text,pictureID integer,rating float NOT NULL DEFAULT 0,sort text COLLATE NOCASE,language text,audience text,rightsHolder text,status integer DEFAULT 0);
CREATE TABLE resourceFormat (id integer NOT NULL PRIMARY KEY AUTOINCREMENT,format text NOT NULL,length double NOT NULL DEFAULT 0,lengthUnit text NOT NULL DEFAULT pp,description text NOT NULL DEFAULT na,resourceID integer NOT NULL,locationID integer);
CREATE TABLE resource_collection_link (id integer NOT NULL PRIMARY KEY AUTOINCREMENT UNIQUE,resourceID integer NOT NULL,collectionID integer NOT NULL, resourceIndexInCollection integer DEFAULT 1);
CREATE TABLE resource_annotations_link (id integer NOT NULL PRIMARY KEY AUTOINCREMENT,resourceID integer NOT NULL,annotationsID integer NOT NULL);
CREATE TABLE resource_contributor_link (id integer NOT NULL PRIMARY KEY AUTOINCREMENT,resourceID integer NOT NULL,contributorID integer NOT NULL,role varchar DEFAULT aut COLLATE NOCASE,contributorIndexInList integer DEFAULT 1);
CREATE TABLE resource_reviews_link (id integer NOT NULL PRIMARY KEY AUTOINCREMENT UNIQUE,resourceID integer NOT NULL,reviewID integer NOT NULL);
CREATE TABLE reviews (id integer NOT NULL PRIMARY KEY AUTOINCREMENT UNIQUE,content text NOT NULL, pubDate date DEFAULT CURRENT_DATE,source text);
CREATE VIEW ComicsResources AS SELECT DISTINCT a.* from resource as A,resourceFormat as B WHERE ((b.format='cbr' or b.format='cbz' or b.format='cb7' or b.format='cba' or b.format='cbt' or b.format='lzh' or a.type='comic') and a.id=b.resourceID);
CREATE VIEW EBookResources AS SELECT DISTINCT a.* from resource as A,resourceFormat as B WHERE ((b.format='epub' or b.format='ibooks' or b.format='odt' or b.format='azw' or b.format='azw3' or b.format='mobi' or b.format='lit' or b.format='chm' or b.format='djvu') and a.id=b.resourceID);
CREATE VIEW PDFResources AS SELECT DISTINCT a.* from resource as A,resourceFormat as B WHERE (b.format='pdf' and a.id=b.resourceID);
CREATE VIEW TextResources AS SELECT DISTINCT a.* from resource as A,resourceFormat as B WHERE ((b.format='rtf' or b.format='doc' or b.format='docx' or b.format='txt') and a.id=b.resourceID);